diff -ruN strongswan-5.8.4/src/libstrongswan/networking/wintun_support.h strongswancont-5.8.4-svc/src/libstrongswan/networking/wintun_support.h
--- strongswan-5.8.4/src/libstrongswan/networking/wintun_support.h	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/networking/wintun_support.h	2022-12-08 11:10:58.503375000 +0300
@@ -0,0 +1,103 @@
+/*
+ * Copyright (C) 2020 thermi
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/* 
+ * File:   wintun_support.h
+ * Author: thermi
+ *
+ * Created on 12. Mai 2020, 23:04
+ */
+
+#ifndef WINTUN_SUPPORT_H
+#define WINTUN_SUPPORT_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include "windows_tun.h"
+#include "tlhelp32.h"
+#include "securitybaseapi.h"
+	
+#define TUN_PACKET_ALIGNMENT 4
+#define TUN_RING_CAPACITY (16*1024*1024)
+#define TUN_MAX_IP_PACKET_SIZE 0xFFFF
+#define WINTUN_RING_TRAILING_BYTES 0x10000
+
+typedef struct _TUN_PACKET_HEADER {
+	uint32_t size;
+} TUN_PACKET_HEADER;
+
+typedef struct _TUN_PACKET {
+	ULONG Size;
+	UCHAR Data[TUN_MAX_IP_PACKET_SIZE];
+} TUN_PACKET;
+
+#define TUN_TRAILING_SIZE (sizeof(TUN_PACKET) + ((TUN_MAX_IP_PACKET_SIZE + \
+	(TUN_PACKET_ALIGNMENT - 1)) &~ (TUN_PACKET_ALIGNMENT - 1)) - \
+	TUN_PACKET_ALIGNMENT)
+
+typedef struct _TUN_RING {
+	volatile ULONG Head;
+	volatile ULONG Tail;
+	volatile LONG Alertable;
+	UCHAR Data[];
+} TUN_RING;
+
+typedef struct _TUN_REGISTER_RINGS {
+	struct {
+		ULONG RingSize;
+		TUN_RING *Ring;
+		HANDLE TailMoved;
+	} Send, Receive;
+	/* Send ring is for data from driver to application */
+	/* Receive ring is for data from application to driver */
+} TUN_REGISTER_RINGS;
+
+#define TUN_RING_SIZE (sizeof(TUN_RING) + TUN_RING_CAPACITY + 0x10000)
+
+/* capacity must be a power of two and between 128 kiB and 64 MiB */
+#define IFNAMSIZ 256
+
+#define PNP_INSTANCE_ID "{abcde}"
+#define WINTUN_COMPONENT_ID "Wintun"
+/* for use with SetDeviceRegistryPropertyString */
+#define STRONGSWAN_WINTUN_INTERFACE_NAME "strongSwan VPN adapter"
+#define STRONGSWAN_WINTUN_DEVICE_ID "STRONGSWAN"
+/* Randomly generated, globally unique GUID for the strongSwan VPN adapter*/
+const static GUID GUID_WINTUN_STRONGSWAN = { 0x1f1f4dd1L, 0xe4d8, 0x487d, { 0xb7, 0xd5, 0x24, 0x93, 0xb2, 0xce, 0x0c, 0x49 } };
+const static GUID GUID_INTERFACE_NET = {0xcac88484L, 0x7515, 0x4c03, {0x82, 0xe6, 0x71, 0xa8, 0x7a, 0xba, 0xc3, 0x61}};
+
+const static char GUID_WINTUN_STRONGSWAN_STRING[] = "1f1f4dd1-e4d8-487d-b7d5-2493b2ce0c49";
+/* GUIDs from openvpn tun.c code */
+const static GUID GUID_DEVCLASS_NET = { 0x4d36e972L, 0xe325, 0x11ce, { 0xbf, 0xc1, 0x08, 0x00, 0x2b, 0xe1, 0x03, 0x18 } };
+#define TUN_IOCTL_REGISTER_RINGS 0xca6ce5c0
+//#define TUN_IOCTL_REGISTER_RINGS ((51820 << 16) | (0x970 << 2) | 0 /*METHOD_BUFFERED*/ | (0x3 /*FILE_READ_DATA | FILE_WRITE_DATA*/ << 14))
+#define TUN_PACKET_TRAILING_SIZE (sizeof(uint32_t) + ((TUN_MAX_IP_PACKET_SIZE + \
+	(TUN_PACKET_ALIGNMENT - 1)) &~(TUN_PACKET_ALIGNMENT - 1)) - TUN_PACKET_ALIGNMENT)
+#define TUN_WRAP_POSITION(position, size) ((position & (size - 1)))
+#define TUN_PACKET_ALIGN(size) ((size + (TUN_PACKET_ALIGNMENT - 1)) &~(TUN_PACKET_ALIGNMENT - 1))
+
+tun_device_t *try_configure_wintun(const char *name_tmpl);
+
+bool delete_existing_strongswan_wintun_devices();
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* WINTUN_SUPPORT_H */
\ В конце файла нет новой строки
diff -ruN strongswan-5.8.4/src/libstrongswan/plugins/gmp/gmp_rsa_public_key.c strongswancont-5.8.4-svc/src/libstrongswan/plugins/gmp/gmp_rsa_public_key.c
--- strongswan-5.8.4/src/libstrongswan/plugins/gmp/gmp_rsa_public_key.c	2018-12-14 18:48:24.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/plugins/gmp/gmp_rsa_public_key.c	2022-07-06 15:47:34.862985000 +0300
@@ -168,7 +168,7 @@
 	int i;
 	bool success = FALSE;
 
-	if (!params)
+	if (!params || params->salt_len < 0)
 	{
 		return FALSE;
 	}
diff -ruN strongswan-5.8.4/src/libstrongswan/plugins/openssl/openssl_crl.c strongswancont-5.8.4-svc/src/libstrongswan/plugins/openssl/openssl_crl.c
--- strongswan-5.8.4/src/libstrongswan/plugins/openssl/openssl_crl.c	2018-12-14 18:48:24.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/plugins/openssl/openssl_crl.c	2022-07-06 15:47:34.862985000 +0300
@@ -288,6 +288,7 @@
 	private_openssl_crl_t *this, certificate_t *issuer,
 	signature_params_t **scheme)
 {
+	chunk_t keyid = chunk_empty;
 	chunk_t fingerprint, tbs;
 	public_key_t *key;
 	x509_t *x509;
@@ -312,13 +313,31 @@
 	{
 		return FALSE;
 	}
+
+
+	if (this->authKeyIdentifier.ptr)
+	{
+		keyid = x509->get_subjectKeyIdentifier(x509);
+		if (keyid.len && !chunk_equals(keyid, this->authKeyIdentifier))
+		{
+			return FALSE;
+		}
+	}
+	if (!keyid.len)
+	{
+		if (!this->issuer->equals(this->issuer, issuer->get_subject(issuer)))
+		{
+			return FALSE;
+		}
+	}
+	/*
 	if (this->authKeyIdentifier.ptr && key)
 	{
 		if (!key->get_fingerprint(key, KEYID_PUBKEY_SHA1, &fingerprint) ||
 			!chunk_equals(fingerprint, this->authKeyIdentifier))
 		{
 			return FALSE;
-		}
+		}		
 	}
 	else
 	{
@@ -327,6 +346,8 @@
 			return FALSE;
 		}
 	}
+	*/
+
 	/* i2d_re_X509_CRL_tbs() was added with 1.1.0 when X509_CRL became opaque */
 #if OPENSSL_VERSION_NUMBER >= 0x10100000L
 	tbs = openssl_i2chunk(re_X509_CRL_tbs, this->crl);
diff -ruN strongswan-5.8.4/src/libstrongswan/plugins/openssl/openssl_x509.c strongswancont-5.8.4-svc/src/libstrongswan/plugins/openssl/openssl_x509.c
--- strongswan-5.8.4/src/libstrongswan/plugins/openssl/openssl_x509.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/plugins/openssl/openssl_x509.c	2022-07-06 15:47:34.862985000 +0300
@@ -1142,6 +1142,13 @@
 					chunk, BUILD_END);
 			free(chunk.ptr);
 			break;
+		case OID_BIGN_PUB_KEY:
+				chunk = openssl_i2chunk(X509_PUBKEY, X509_get_X509_PUBKEY(this->x509));
+				this->pubkey = lib->creds->create(lib->creds,
+					CRED_PUBLIC_KEY, KEY_BIGN, BUILD_BLOB_ASN1_DER,
+ 					chunk, BUILD_END);
+ 			free(chunk.ptr);
+ 			break;
 		default:
 			DBG1(DBG_LIB, "unsupported public key algorithm");
 			break;
diff -ruN strongswan-5.8.4/src/libstrongswan/plugins/test_vectors/test_vectors/rng.c strongswancont-5.8.4-svc/src/libstrongswan/plugins/test_vectors/test_vectors/rng.c
--- strongswan-5.8.4/src/libstrongswan/plugins/test_vectors/test_vectors/rng.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/plugins/test_vectors/test_vectors/rng.c	2023-05-15 14:37:42.918947000 +0300
@@ -44,7 +44,7 @@
 			}
 		}
 	}
-	DBG2(DBG_LIB, "  Monobit: %d/%d bits set", bits, data.len * 8);
+	DBG1(DBG_LIB, "  Monobit: %d/%d bits set", bits, data.len * 8);
 	if (bits > param->lower && bits < param->upper)
 	{
 		return TRUE;
@@ -101,7 +101,7 @@
 		sum += (counter[i] * counter[i]) / 5000.0 * 16.0;
 	}
 	sum -= 5000.0;
-	DBG2(DBG_LIB, "  Poker: %f", sum);
+	DBG1(DBG_LIB, "  Poker: %f", sum);
 	if (sum > param->lower && sum < param->upper)
 	{
 		return TRUE;
@@ -190,7 +190,7 @@
 		}
 	}
 
-	DBG2(DBG_LIB, "  Runs: zero: %d/%d/%d/%d/%d/%d, one: %d/%d/%d/%d/%d/%d, "
+	DBG1(DBG_LIB, "  Runs: zero: %d/%d/%d/%d/%d/%d, one: %d/%d/%d/%d/%d/%d, "
 		 "longruns: %d",
 		 zero_runs[1], zero_runs[2], zero_runs[3],
 		 zero_runs[4], zero_runs[5], zero_runs[6],
diff -ruN strongswan-5.8.4/src/libstrongswan/plugins/x509/x509_cert.c strongswancont-5.8.4-svc/src/libstrongswan/plugins/x509/x509_cert.c
--- strongswan-5.8.4/src/libstrongswan/plugins/x509/x509_cert.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/plugins/x509/x509_cert.c	2023-06-15 16:21:26.117463000 +0300
@@ -202,6 +202,11 @@
 	x509_flag_t flags;
 
 	/**
+	 * x509 key usage
+	 */
+	x509_key_usage_t keyUsage;
+
+	/**
 	 * Signature scheme
 	 */
 	signature_params_t *scheme;
@@ -736,18 +741,33 @@
 					{
 						case KU_CRL_SIGN:
 							this->flags |= X509_CRL_SIGN;
+							this->keyUsage |= X509_KU_CRL_SIGN;
+							break;
+						case KU_KEY_CERT_SIGN:
+							/* we use the caBasicConstraint, MUST be set */
+							this->keyUsage |= X509_KU_KEY_CERT_SIGN;							
 							break;
 						case KU_DIGITAL_SIGNATURE:
+							this->keyUsage |= X509_KU_DIGITAL_SIGNATURE;
+							break;
 						case KU_NON_REPUDIATION:
 							this->flags |= X509_IKE_COMPLIANT;
-							break;
-						case KU_KEY_CERT_SIGN:
-							/* we use the caBasicConstraint, MUST be set */
+							this->keyUsage |= X509_KU_NON_REPUDIATION;
+							break;						
 						case KU_KEY_ENCIPHERMENT:
+							this->keyUsage |= X509_KU_KEY_ENCIPHERMENT;
+							break;
 						case KU_DATA_ENCIPHERMENT:
+							this->keyUsage |= X509_KU_DATA_ENCIPHERMENT;
+							break;
 						case KU_KEY_AGREEMENT:
+							this->keyUsage |= X509_KU_KEY_AGREEMENT;
+							break;
 						case KU_ENCIPHER_ONLY:
+							this->keyUsage |= X509_KU_ENCIPHER_ONLY;
+							break;
 						case KU_DECIPHER_ONLY:
+							this->keyUsage |= X509_KU_DECIPHER_ONLY;
 							break;
 					}
 				}
@@ -1830,6 +1850,12 @@
 	return this->flags;
 }
 
+METHOD(x509_t, get_keyUsage, x509_key_usage_t,
+	private_x509_cert_t *this)
+{
+	return this->keyUsage;
+}
+
 METHOD(x509_t, get_serial, chunk_t,
 	private_x509_cert_t *this)
 {
@@ -1846,7 +1872,6 @@
 	else
 	{
 		chunk_t fingerprint;
-
 		if (this->public_key->get_fingerprint(this->public_key,
 									KEYID_PUBKEY_SHA1, &fingerprint))
 		{
@@ -1992,6 +2017,7 @@
 					.destroy = _destroy,
 				},
 				.get_flags = _get_flags,
+				.get_keyUsage = _get_keyUsage,
 				.get_serial = _get_serial,
 				.get_subjectKeyIdentifier = _get_subjectKeyIdentifier,
 				.get_authKeyIdentifier = _get_authKeyIdentifier,
@@ -2043,6 +2069,9 @@
 		case ID_DER_ASN1_DN:
 			context = ASN1_CONTEXT_C_4;
 			break;
+		case ID_DER_ASN1_GN_URI:
+			context = ASN1_CONTEXT_S_6;
+			break;
 		case ID_IPV4_ADDR:
 		case ID_IPV6_ADDR:
 			context = ASN1_CONTEXT_S_7;
@@ -2319,11 +2348,16 @@
 												chunk_from_chars(0xFF)),
 											pathLenConstraint)));
 		/* set CertificateSign and implicitly CRLsign */
-		keyUsageBits = keyUsageCertSignCrlSign;
+		//keyUsageBits = keyUsageCertSignCrlSign;
+		keyUsageBits = chunk_from_chars(0x01, 0x06);
+		cert->keyUsage |= X509_KU_KEY_CERT_SIGN;
+		cert->keyUsage |= X509_KU_CRL_SIGN;
 	}
 	else if (cert->flags & X509_CRL_SIGN)
 	{
-		keyUsageBits = keyUsageCrlSign;
+		//keyUsageBits = keyUsageCrlSign;
+		keyUsageBits = chunk_from_chars(0x01, 0x02);
+		cert->keyUsage |= X509_KU_CRL_SIGN;
 	}
 	if (keyUsageBits.len)
 	{
@@ -2367,8 +2401,9 @@
 										ocspSigning, msSmartcardLogon)));
 	}
 
-	/* add subjectKeyIdentifier to CA and OCSP signer certificates */
-	if (cert->flags & (X509_CA | X509_OCSP_SIGNER | X509_CRL_SIGN))
+	/* add subjectKeyIdentifier to CA and OCSP signer certificates and BIGN certificates */
+	if ((cert->flags & (X509_CA | X509_OCSP_SIGNER | X509_CRL_SIGN)) ||
+		(cert->public_key->get_type(cert->public_key) == KEY_BIGN))
 	{
 		chunk_t keyid;
 
diff -ruN strongswan-5.8.4/src/libstrongswan/plugins/x509/x509_pkcs10.c strongswancont-5.8.4-svc/src/libstrongswan/plugins/x509/x509_pkcs10.c
--- strongswan-5.8.4/src/libstrongswan/plugins/x509/x509_pkcs10.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/plugins/x509/x509_pkcs10.c	2023-06-12 16:07:13.535787000 +0300
@@ -24,6 +24,7 @@
 #include <credentials/keys/private_key.h>
 #include <collections/linked_list.h>
 #include <utils/identification.h>
+#include <time.h>
 
 typedef struct private_x509_pkcs10_t private_x509_pkcs10_t;
 
@@ -72,6 +73,11 @@
 	chunk_t challengePassword;
 
 	/**
+	 * certificate validity
+	 */
+	chunk_t certificateValidity;
+
+	/**
 	 * Signature scheme
 	 */
 	signature_params_t *scheme;
@@ -95,6 +101,16 @@
 	 * reference count
 	 */
 	refcount_t ref;
+
+	/**
+	 * validity starts
+	 */
+	time_t notBefore;
+
+	/**
+	 * validity ends
+	 */
+	time_t notAfter;
 };
 
 /**
@@ -481,6 +497,7 @@
 		{	/* only parsed certificate requests point these fields to "encoded" */
 			chunk_free(&this->certificationRequestInfo);
 			chunk_free(&this->challengePassword);
+			chunk_free(&this->certificateValidity);
 			chunk_free(&this->signature);
 		}
 		free(this);
@@ -522,15 +539,77 @@
 	return this;
 }
 
+
+static chunk_t build_msExtensions(private_x509_pkcs10_t *cert, bool is78,
+								  chunk_t *subjectAltNames, chunk_t *certificatePolicies)
+{
+	chunk_t extensions = chunk_empty;
+
+	chunk_t subjectKeyId = chunk_empty;
+	chunk_t keyUsage = chunk_empty;	
+//	chunk_t basicConstraints = chunk_empty;
+
+	chunk_t keyId = chunk_empty;
+	
+	if(!cert->public_key->get_fingerprint(cert->public_key, KEYID_PUBKEY_BELT, &keyId))
+	{
+		DBG1(DBG_CNT, "unable to get public key identifier");
+		return extensions;
+	}
+
+	subjectKeyId = asn1_wrap(ASN1_SEQUENCE, "mm",
+					asn1_build_known_oid(OID_SUBJECT_KEY_ID),
+					asn1_wrap(ASN1_OCTET_STRING, "m",
+						asn1_wrap(ASN1_OCTET_STRING, "m", keyId)));
+
+	keyUsage = asn1_wrap(ASN1_SEQUENCE, "mmm",
+					asn1_build_known_oid(OID_KEY_USAGE),
+					asn1_wrap(ASN1_BOOLEAN, "c", chunk_from_chars(0xFF)),
+					asn1_wrap(ASN1_OCTET_STRING, "m",
+						asn1_wrap(ASN1_BIT_STRING, "c",
+							chunk_from_chars(0x05, 0xE0))));
+
+//	basicConstraints = asn1_wrap(ASN1_SEQUENCE, "mmm",
+//							asn1_build_known_oid(OID_BASIC_CONSTRAINTS),
+//							asn1_wrap(ASN1_BOOLEAN, "c", chunk_from_chars(0xFF)),
+//							asn1_wrap(ASN1_OCTET_STRING, "m",
+//								asn1_wrap(ASN1_SEQUENCE, "")));
+
+	int exts_request_oid = OID_MS_CERTIFICATE_EXTENSIONS;
+	if (is78)
+	{
+		exts_request_oid = OID_EXTENSION_REQUEST;
+	}
+	extensions = asn1_wrap(ASN1_SEQUENCE, "mm",
+					asn1_build_known_oid(exts_request_oid),
+					asn1_wrap(ASN1_SET, "m",
+						asn1_wrap(ASN1_SEQUENCE, "mmmm",
+//						asn1_wrap(ASN1_SEQUENCE, "mmmmm",
+							subjectKeyId,
+							keyUsage,
+							*certificatePolicies,
+//							basicConstraints,
+							*subjectAltNames)));
+
+	return extensions;
+}
+
+#define YEAR_SEC 365 * 24 * 60 * 60
+
+#define BPKI_MASK_VALIDITY            0x0F
+#define BPKI_MASK_GOVPKI              0x10
+#define BPKI_MASK_78_EXTS_REQUEST_OID 0x20
+
 /**
  * Generate and sign a new certificate request
  */
-static bool generate(private_x509_pkcs10_t *cert, private_key_t *sign_key,
-					 int digest_alg)
+static bool generate(private_x509_pkcs10_t *cert, bool bpki, uint8_t flags,
+					 private_key_t *sign_key, int digest_alg)
 {
 	chunk_t key_info, subjectAltNames, attributes;
-	chunk_t extensionRequest  = chunk_empty;
-	chunk_t challengePassword = chunk_empty, sig_scheme = chunk_empty;
+	chunk_t extensionRequest  = chunk_empty, challengePassword = chunk_empty;
+	chunk_t certificateValidity = chunk_empty, sig_scheme = chunk_empty;
+	chunk_t certificatePolicies = chunk_empty;
 	identification_t *subject;
 
 	subject = cert->subject;
@@ -564,13 +643,63 @@
 	/* encode subjectAltNames */
 	subjectAltNames = x509_build_subjectAltNames(cert->subjectAltNames);
 
-	if (subjectAltNames.ptr)
+	if (bpki)
 	{
-		extensionRequest = asn1_wrap(ASN1_SEQUENCE, "mm",
-					asn1_build_known_oid(OID_EXTENSION_REQUEST),
-					asn1_wrap(ASN1_SET, "m",
-						asn1_wrap(ASN1_SEQUENCE, "m", subjectAltNames)
-					));
+		// certificate validity
+		uint8_t years = flags & BPKI_MASK_VALIDITY;
+		if (years > 0 && years <= 3)
+		{
+			cert->notBefore = time(NULL);
+			cert->notAfter = cert->notBefore + (YEAR_SEC*years);
+
+			certificateValidity = asn1_wrap(ASN1_SEQUENCE, "mm",
+					asn1_build_known_oid(OID_BPKI_AT_CERTIFICATE_VALIDITY),
+					asn1_wrap(ASN1_SEQUENCE, "mm",
+						asn1_from_time(&cert->notBefore, ASN1_UTCTIME),
+						asn1_from_time(&cert->notAfter, ASN1_UTCTIME)));
+		}
+
+		// certificate policies
+		if (flags & BPKI_MASK_GOVPKI)
+		{
+			certificatePolicies = asn1_wrap(ASN1_SEQUENCE, "mm",
+							asn1_build_known_oid(OID_CERTIFICATE_POLICIES),
+							asn1_wrap(ASN1_OCTET_STRING, "m",
+								asn1_wrap(ASN1_SEQUENCE, "mm", 
+									asn1_wrap(ASN1_SEQUENCE, "m",
+										asn1_build_known_oid(OID_BPKI_ROLE_ACD)),
+									asn1_wrap(ASN1_SEQUENCE, "m",
+										asn1_build_known_oid(OID_GOVPKI_CA2_TECHCERT)))));
+
+		}
+		else
+		{
+			certificatePolicies = asn1_wrap(ASN1_SEQUENCE, "mm",
+							asn1_build_known_oid(OID_CERTIFICATE_POLICIES),
+							asn1_wrap(ASN1_OCTET_STRING, "m",
+								asn1_wrap(ASN1_SEQUENCE, "m",
+									asn1_wrap(ASN1_SEQUENCE, "m",
+										asn1_build_known_oid(OID_BPKI_ROLE_ACD)))));
+		}
+
+		extensionRequest = build_msExtensions(cert, flags & BPKI_MASK_78_EXTS_REQUEST_OID,
+											  &subjectAltNames, &certificatePolicies);
+		if(!extensionRequest.ptr)
+		{
+			chunk_free(&sig_scheme);
+			return FALSE;
+		}
+	}
+	else
+	{
+		if (subjectAltNames.ptr)
+		{
+			extensionRequest = asn1_wrap(ASN1_SEQUENCE, "mm",
+						asn1_build_known_oid(OID_EXTENSION_REQUEST),
+						asn1_wrap(ASN1_SET, "m",
+							asn1_wrap(ASN1_SEQUENCE, "m", subjectAltNames)
+						));
+		}
 	}
 	if (cert->challengePassword.len > 0)
 	{
@@ -584,8 +713,11 @@
 					)
 			);
 	}
-	attributes = asn1_wrap(ASN1_CONTEXT_C_0, "mm", extensionRequest,
-												   challengePassword);
+
+	attributes = asn1_wrap(ASN1_CONTEXT_C_0, "mmm",
+					challengePassword,
+					extensionRequest,
+					certificateValidity);
 
 	cert->certificationRequestInfo = asn1_wrap(ASN1_SEQUENCE, "ccmm",
 							ASN1_INTEGER_0,
@@ -604,6 +736,7 @@
 							   cert->certificationRequestInfo,
 							   sig_scheme,
 							   asn1_bitstring("c", cert->signature));
+
 	return TRUE;
 }
 
@@ -652,6 +785,8 @@
 	private_x509_pkcs10_t *cert;
 	private_key_t *sign_key = NULL;
 	hash_algorithm_t digest_alg = HASH_SHA1;
+	bool bpki = FALSE;
+	uint8_t flags = 0;
 
 	cert = create_empty();
 	while (TRUE)
@@ -691,6 +826,24 @@
 			case BUILD_DIGEST_ALG:
 				digest_alg = va_arg(args, int);
 				continue;
+			case BUILD_BPKI_PKCS10:
+				bpki = (va_arg(args, int));
+				continue;
+			case BUILD_CERT_VALIDITY:
+				flags |= ((va_arg(args, int)) & BPKI_MASK_VALIDITY);
+				continue;
+			case BUILD_POLICY_GOVPKI:
+				if(va_arg(args, int))
+				{
+					flags |= BPKI_MASK_GOVPKI;					
+				}
+				continue;
+			case BUILD_78_EXTS_REQUEST_OID:
+				if(va_arg(args, int))
+				{
+					flags |= BPKI_MASK_78_EXTS_REQUEST_OID;					
+				}
+				continue;
 			case BUILD_END:
 				break;
 			default:
@@ -700,10 +853,11 @@
 		break;
 	}
 
-	if (sign_key && generate(cert, sign_key, digest_alg))
+	if (sign_key && generate(cert, bpki, flags, sign_key, digest_alg))
 	{
 		return &cert->public;
 	}
+
 	destroy(cert);
 	return NULL;
 }
diff -ruN strongswan-5.8.4/src/libstrongswan/processing/scheduler.c strongswancont-5.8.4-svc/src/libstrongswan/processing/scheduler.c
--- strongswan-5.8.4/src/libstrongswan/processing/scheduler.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/processing/scheduler.c	2022-07-06 15:47:35.518995000 +0300
@@ -94,30 +94,6 @@
 };
 
 /**
- * Compares two timevals, return >0 if a > b, <0 if a < b and =0 if equal
- */
-static int timeval_cmp(timeval_t *a, timeval_t *b)
-{
-	if (a->tv_sec > b->tv_sec)
-	{
-		return 1;
-	}
-	if (a->tv_sec < b->tv_sec)
-	{
-		return -1;
-	}
-	if (a->tv_usec > b->tv_usec)
-	{
-		return 1;
-	}
-	if (a->tv_usec < b->tv_usec)
-	{
-		return -1;
-	}
-	return 0;
-}
-
-/**
  * Returns the top event without removing it. Returns NULL if the heap is empty.
  */
 static event_t *peek_event(private_scheduler_t *this)
@@ -144,21 +120,22 @@
 
 	if (--this->event_count > 1)
 	{
-		/* seep down the top event */
 		u_int position = 1;
+
+		/* seep down the top event */
 		while ((position << 1) <= this->event_count)
 		{
 			u_int child = position << 1;
 
 			if ((child + 1) <= this->event_count &&
-				timeval_cmp(&this->heap[child + 1]->time,
-							&this->heap[child]->time) < 0)
+				timercmp(&this->heap[child + 1]->time,
+						 &this->heap[child]->time, <))
 			{
 				/* the "right" child is smaller */
 				child++;
 			}
 
-			if (timeval_cmp(&top->time, &this->heap[child]->time) <= 0)
+			if (!timercmp(&top->time, &this->heap[child]->time, >))
 			{
 				/* the top event fires before the smaller of the two children,
 				 * stop */
@@ -189,7 +166,7 @@
 
 	if ((event = peek_event(this)) != NULL)
 	{
-		if (timeval_cmp(&now, &event->time) >= 0)
+		if (!timercmp(&now, &event->time, <))
 		{
 			remove_event(this);
 			this->mutex->unlock(this->mutex);
@@ -262,8 +239,8 @@
 	position = this->event_count;
 
 	/* then bubble it up */
-	while (position > 1 && timeval_cmp(&this->heap[position >> 1]->time,
-									   &event->time) > 0)
+	while (position > 1 &&
+		   timercmp(&this->heap[position >> 1]->time, &event->time, >))
 	{
 		/* parent has to be fired after the new event, move up */
 		this->heap[position] = this->heap[position >> 1];
diff -ruN strongswan-5.8.4/src/libstrongswan/tests/suites/test_crypter.c strongswancont-5.8.4-svc/src/libstrongswan/tests/suites/test_crypter.c
--- strongswan-5.8.4/src/libstrongswan/tests/suites/test_crypter.c	2019-08-27 16:27:26.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/tests/suites/test_crypter.c	2022-07-06 15:47:35.566996000 +0300
@@ -34,6 +34,11 @@
 	{ OID_AES128_CBC, ENCR_AES_CBC, 128 },
 	{ OID_AES192_CBC, ENCR_AES_CBC, 192 },
 	{ OID_AES256_CBC, ENCR_AES_CBC, 256 },
+	{ OID_GOST28147_CTR, ENCR_GOST28147_CTR, 256 },
+	{ OID_GOST28147_CFB, ENCR_GOST28147_CFB, 256 },
+	{ OID_BELT_CBC, ENCR_BELT_CBC, 256 },
+	{ OID_BELT_CFB, ENCR_BELT_CFB, 256 },
+	{ OID_BELT_CTR, ENCR_BELT_CTR, 256 },
 	{ OID_CAMELLIA128_CBC, ENCR_CAMELLIA_CBC, 128 },
 	{ OID_CAMELLIA192_CBC, ENCR_CAMELLIA_CBC, 192 },
 	{ OID_CAMELLIA256_CBC, ENCR_CAMELLIA_CBC, 256 },
diff -ruN strongswan-5.8.4/src/libstrongswan/tests/suites/test_hasher.c strongswancont-5.8.4-svc/src/libstrongswan/tests/suites/test_hasher.c
--- strongswan-5.8.4/src/libstrongswan/tests/suites/test_hasher.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/tests/suites/test_hasher.c	2022-07-06 15:47:35.518995000 +0300
@@ -35,39 +35,40 @@
 	{ OID_SHA256, HASH_SHA256, KEY_ANY },                          /*  4 */
 	{ OID_SHA384, HASH_SHA384, KEY_ANY },                          /*  5 */
 	{ OID_SHA512, HASH_SHA512, KEY_ANY },                          /*  6 */
-	{ OID_SHA3_224, HASH_SHA3_224, KEY_ANY },                      /*  7 */
-	{ OID_SHA3_256, HASH_SHA3_256, KEY_ANY },                      /*  8 */
-	{ OID_SHA3_384, HASH_SHA3_384, KEY_ANY },                      /*  9 */
-	{ OID_SHA3_512, HASH_SHA3_512, KEY_ANY },                      /* 10 */
-	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ANY },                        /* 11 */
-	{ OID_MD2_WITH_RSA, HASH_MD2, KEY_RSA },                       /* 12 */
-	{ OID_MD5_WITH_RSA, HASH_MD5, KEY_RSA },                       /* 13 */
-	{ OID_SHA1_WITH_RSA, HASH_SHA1, KEY_RSA },                     /* 14 */
-	{ OID_SHA224_WITH_RSA, HASH_SHA224, KEY_RSA },                 /* 15 */
-	{ OID_SHA256_WITH_RSA, HASH_SHA256, KEY_RSA },                 /* 16 */
-	{ OID_SHA384_WITH_RSA, HASH_SHA384, KEY_RSA },                 /* 17 */
-	{ OID_SHA512_WITH_RSA, HASH_SHA512, KEY_RSA },                 /* 18 */
-	{ OID_RSASSA_PKCS1V15_WITH_SHA3_224, HASH_SHA3_224, KEY_RSA }, /* 19 */
-	{ OID_RSASSA_PKCS1V15_WITH_SHA3_256, HASH_SHA3_256, KEY_RSA }, /* 20 */
-	{ OID_RSASSA_PKCS1V15_WITH_SHA3_384, HASH_SHA3_384, KEY_RSA }, /* 21 */
-	{ OID_RSASSA_PKCS1V15_WITH_SHA3_512, HASH_SHA3_512, KEY_RSA }, /* 22 */
-	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_RSA },                        /* 23 */
-	{ OID_ED25519, HASH_IDENTITY, KEY_ED25519 },                   /* 24 */
-	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ED25519 },                    /* 25 */
-	{ OID_ED448, HASH_IDENTITY, KEY_ED448 },                       /* 26 */
-	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ED448 },                      /* 27 */
-	{ OID_ECDSA_WITH_SHA1, HASH_SHA1, KEY_ECDSA },                 /* 28 */
-	{ OID_ECDSA_WITH_SHA256, HASH_SHA256, KEY_ECDSA },             /* 29 */
-	{ OID_ECDSA_WITH_SHA384, HASH_SHA384, KEY_ECDSA },             /* 30 */
-	{ OID_ECDSA_WITH_SHA512, HASH_SHA512, KEY_ECDSA },             /* 31 */
-	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ECDSA },                      /* 32 */
-	{ OID_BLISS_WITH_SHA2_256, HASH_SHA256, KEY_BLISS },           /* 33 */
-	{ OID_BLISS_WITH_SHA2_384, HASH_SHA384, KEY_BLISS },           /* 34 */
-	{ OID_BLISS_WITH_SHA2_512, HASH_SHA512, KEY_BLISS },           /* 35 */
-	{ OID_BLISS_WITH_SHA3_256, HASH_SHA3_256, KEY_BLISS },         /* 36 */
-	{ OID_BLISS_WITH_SHA3_384, HASH_SHA3_384, KEY_BLISS },         /* 37 */
-	{ OID_BLISS_WITH_SHA3_512, HASH_SHA3_512, KEY_BLISS },         /* 38 */
-	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_BLISS },                      /* 39 */
+	{ OID_BELT_HASH, BELT_HASH, KEY_ANY },                         /*  7 */
+	{ OID_SHA3_224, HASH_SHA3_224, KEY_ANY },                      /*  8 */
+	{ OID_SHA3_256, HASH_SHA3_256, KEY_ANY },                      /*  9 */
+	{ OID_SHA3_384, HASH_SHA3_384, KEY_ANY },                      /* 10 */
+	{ OID_SHA3_512, HASH_SHA3_512, KEY_ANY },                      /* 11 */
+	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ANY },                        /* 12 */
+	{ OID_MD2_WITH_RSA, HASH_MD2, KEY_RSA },                       /* 13 */
+	{ OID_MD5_WITH_RSA, HASH_MD5, KEY_RSA },                       /* 14 */
+	{ OID_SHA1_WITH_RSA, HASH_SHA1, KEY_RSA },                     /* 15 */
+	{ OID_SHA224_WITH_RSA, HASH_SHA224, KEY_RSA },                 /* 16 */
+	{ OID_SHA256_WITH_RSA, HASH_SHA256, KEY_RSA },                 /* 17 */
+	{ OID_SHA384_WITH_RSA, HASH_SHA384, KEY_RSA },                 /* 18 */
+	{ OID_SHA512_WITH_RSA, HASH_SHA512, KEY_RSA },                 /* 19 */
+	{ OID_RSASSA_PKCS1V15_WITH_SHA3_224, HASH_SHA3_224, KEY_RSA }, /* 20 */
+	{ OID_RSASSA_PKCS1V15_WITH_SHA3_256, HASH_SHA3_256, KEY_RSA }, /* 21 */
+	{ OID_RSASSA_PKCS1V15_WITH_SHA3_384, HASH_SHA3_384, KEY_RSA }, /* 22 */
+	{ OID_RSASSA_PKCS1V15_WITH_SHA3_512, HASH_SHA3_512, KEY_RSA }, /* 23 */
+	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_RSA },                        /* 24 */
+	{ OID_ED25519, HASH_IDENTITY, KEY_ED25519 },                   /* 25 */
+	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ED25519 },                    /* 26 */
+	{ OID_ED448, HASH_IDENTITY, KEY_ED448 },                       /* 27 */
+	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ED448 },                      /* 28 */
+	{ OID_ECDSA_WITH_SHA1, HASH_SHA1, KEY_ECDSA },                 /* 29 */
+	{ OID_ECDSA_WITH_SHA256, HASH_SHA256, KEY_ECDSA },             /* 30 */
+	{ OID_ECDSA_WITH_SHA384, HASH_SHA384, KEY_ECDSA },             /* 31 */
+	{ OID_ECDSA_WITH_SHA512, HASH_SHA512, KEY_ECDSA },             /* 32 */
+	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_ECDSA },                      /* 33 */
+	{ OID_BLISS_WITH_SHA2_256, HASH_SHA256, KEY_BLISS },           /* 34 */
+	{ OID_BLISS_WITH_SHA2_384, HASH_SHA384, KEY_BLISS },           /* 35 */
+	{ OID_BLISS_WITH_SHA2_512, HASH_SHA512, KEY_BLISS },           /* 36 */
+	{ OID_BLISS_WITH_SHA3_256, HASH_SHA3_256, KEY_BLISS },         /* 37 */
+	{ OID_BLISS_WITH_SHA3_384, HASH_SHA3_384, KEY_BLISS },         /* 38 */
+	{ OID_BLISS_WITH_SHA3_512, HASH_SHA3_512, KEY_BLISS },         /* 39 */
+	{ OID_UNKNOWN, HASH_UNKNOWN, KEY_BLISS },                      /* 40 */
 
 };
 
diff -ruN strongswan-5.8.4/src/libstrongswan/threading/mutex.c strongswancont-5.8.4-svc/src/libstrongswan/threading/mutex.c
--- strongswan-5.8.4/src/libstrongswan/threading/mutex.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/threading/mutex.c	2022-07-06 15:47:35.570996000 +0300
@@ -239,7 +239,8 @@
 }
 
 /* use the monotonic clock based version of this function if available */
-#ifdef HAVE_PTHREAD_COND_TIMEDWAIT_MONOTONIC
+#if defined(HAVE_PTHREAD_COND_TIMEDWAIT_MONOTONIC) && \
+	!defined(HAVE_CONDATTR_CLOCK_MONOTONIC)
 #define pthread_cond_timedwait pthread_cond_timedwait_monotonic
 #endif
 
@@ -336,7 +337,7 @@
 				pthread_condattr_t condattr;
 				pthread_condattr_init(&condattr);
 #ifdef HAVE_CONDATTR_CLOCK_MONOTONIC
-				pthread_condattr_setclock(&condattr, CLOCK_MONOTONIC);
+				pthread_condattr_setclock(&condattr, TIME_CLOCK_ID);
 #endif
 				pthread_cond_init(&this->condvar, &condattr);
 				pthread_condattr_destroy(&condattr);
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/chunk.c strongswancont-5.8.4-svc/src/libstrongswan/utils/chunk.c
--- strongswan-5.8.4/src/libstrongswan/utils/chunk.c	2019-12-17 01:04:51.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/chunk.c	2023-03-24 14:04:58.275622000 +0300
@@ -347,10 +347,30 @@
 	flags |= O_BINARY;
 #endif
 
+#ifdef WIN32
+	int wlen = 0, fn_len_s = strlen(path);
+	if(fn_len_s == 0)
+	{
+		return NULL;
+	}		
+	wchar_t wpath[MAX_PATH];
+	wlen = MultiByteToWideChar(CP_UTF8, 0, path, fn_len_s, wpath, fn_len_s);
+	if(wlen >= MAX_PATH) 
+	{		
+		return NULL;
+	}
+	wpath[wlen] = L'\0';
+	
+	INIT(chunk,
+		.fd = _wopen(wpath, flags),
+		.wr = wr,
+	);
+#else 
 	INIT(chunk,
 		.fd = open(path, flags),
 		.wr = wr,
 	);
+#endif
 
 	if (chunk->fd == -1)
 	{
@@ -790,7 +810,7 @@
 		{
 			if (sane)
 			{
-				sane->ptr[i] = replace;
+				//sane->ptr[i] = replace;
 			}
 			printable = FALSE;
 		}
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/compat/android.h strongswancont-5.8.4-svc/src/libstrongswan/utils/compat/android.h
--- strongswan-5.8.4/src/libstrongswan/utils/compat/android.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/compat/android.h	2022-07-06 15:47:35.602997000 +0300
@@ -37,6 +37,9 @@
 #define HAVE_PTHREAD_CONDATTR_INIT 1
 #define HAVE_CONDATTR_CLOCK_MONOTONIC 1
 
+#undef TIME_CLOCK_ID
+#define TIME_CLOCK_ID CLOCK_REALTIME
+
 #define HAVE_SYS_CAPABILITY_H 1
 
 #else /* __ANDROID_API__ */
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/compat/unix.h strongswancont-5.8.4-svc/src/libstrongswan/utils/compat/unix.h
--- strongswan-5.8.4/src/libstrongswan/utils/compat/unix.h	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/compat/unix.h	2020-11-30 16:52:55.000000000 +0300
@@ -0,0 +1,15 @@
+
+#ifndef _AFUNIX_
+#define _AFUNIX_
+
+#define UNIX_PATH_MAX 108
+
+typedef struct sockaddr_un
+{
+     ADDRESS_FAMILY sun_family;
+     char sun_path[UNIX_PATH_MAX];
+} SOCKADDR_UN, *PSOCKADDR_UN;
+
+#define SIO_AF_UNIX_GETPEERPID _WSAIOR(IOC_VENDOR, 256)
+
+#endif /* _AFUNIX_ */
